<?php

class OptionController extends RController {

    /**
     * @return array action filters
     */
    public function filters() {
        return array(
            'rights',
            'postOnly + delete', // we only allow deletion via POST request
        );
    }

    /**
     * Displays a particular model.
     * @param integer $id the ID of the model to be displayed
     */
    public function actionView($id) {
        $this->render('view', array(
            'model' => $this->loadModel($id),
        ));
    }

    /**
     * Creates a new model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     */
    public function actionCreate() {
        $model = new Option;
        // Uncomment the following line if AJAX validation is needed
        // $this->performAjaxValidation($model);
        if (isset($_POST['Option'])) {
            $model->attributes = $_POST['Option'];
            if ($model->save())
                $this->redirect(array('view', 'id' => $model->key));
        }
        $this->render('create', array(
            'model' => $model,
        ));
    }

    /**
     * Updates a particular model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id the ID of the model to be updated
     */
    public function actionUpdate($id) {
        $model = $this->loadModel($id);
        // Uncomment the following line if AJAX validation is needed
        // $this->performAjaxValidation($model);
        if (isset($_POST['Option'])) {
            $model->attributes = $_POST['Option'];
            if ($model->save())
                $this->redirect(array('view', 'id' => $model->key));
        }
        $this->render('update', array(
            'model' => $model,
        ));
    }

    public function actionQuickUpdate() {


        if (isset($_POST['striped_protocol']) && in_array($_POST['striped_protocol'], array('http', 'https'))) {
            if (isset($_POST['value'])) {
                $_POST['value'] = "{$_POST['striped_protocol']}://{$_POST['value']}";
            }
        }

        $es = new EditableSaver('Option');
        $es->update();
    }

    /**
     * Deletes a particular model.
     * If deletion is successful, the browser will be redirected to the 'admin' page.
     * @param integer $id the ID of the model to be deleted
     */
    public function actionDelete($id) {
        $this->loadModel($id)->delete();
        // if AJAX request (triggered by deletion via admin grid view), we should not redirect the browser
        if (!isset($_GET['ajax'])) {
            Yii::app()->user->setFlash('alert-success', Yii::t('admin', 'Item has been successfully deleted.'));
            $this->redirect(isset($_POST['returnUrl']) ? $_POST['returnUrl'] : array('admin'));
        }
    }

    /**
     * Manages all models.
     */
    public function actionAdmin() {
        $model = new Option('search');
        $model->unsetAttributes();  // clear any default values
        if (isset($_GET['Option']))
            $model->attributes = $_GET['Option'];
        $this->render('admin', array(
            'model' => $model,
        ));
    }

    /**
     * Returns the data model based on the primary key given in the GET variable.
     * If the data model is not found, an HTTP exception will be raised.
     * @param integer $id the ID of the model to be loaded
     * @return Option the loaded model
     * @throws CHttpException
     */
    public function loadModel($id) {
        $model = Option::model()->findByPk($id);
        if ($model === null)
            throw new CHttpException(404, 'The requested page does not exist.');
        return $model;
    }

    /**
     * Performs the AJAX validation.
     * @param Option $model the model to be validated
     */
    protected function performAjaxValidation($model) {
        if (isset($_POST['ajax']) && $_POST['ajax'] === 'option-form') {
            echo CActiveForm::validate($model);
            Yii::app()->end();
        }
    }

}
